Package org.optaplanner.core.impl.localsearch.decider.acceptor.lateacceptance

## Class LateAcceptanceAcceptor<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter<Solution_>
  - - org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListenerAdapter<Solution_>
    - - org.optaplanner.core.impl.localsearch.decider.acceptor.AbstractAcceptor<Solution_>
      - - org.optaplanner.core.impl.localsearch.decider.acceptor.lateacceptance.LateAcceptanceAcceptor<Solution_>

- All Implemented Interfaces:
    `EventListener`, `Acceptor<Solution_>`, `LocalSearchPhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`

      public class LateAcceptanceAcceptor<Solution_>
      extends AbstractAcceptor<Solution_>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected boolean` | `hillClimbingEnabled` |
    `protected int` | `lateAcceptanceSize` |
    `protected int` | `lateScoreIndex` |
    `protected Score[]` | `previousScores` |

    - ### Fields inherited from class org.optaplanner.core.impl.localsearch.decider.acceptor.AbstractAcceptor

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `LateAcceptanceAcceptor()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `isAccepted​(LocalSearchMoveScope<Solution_> moveScope)` |
    `void` | `phaseEnded​(LocalSearchPhaseScope<Solution_> phaseScope)` |
    `void` | `phaseStarted​(LocalSearchPhaseScope<Solution_> phaseScope)` |
    `void` | `setHillClimbingEnabled​(boolean hillClimbingEnabled)` |
    `void` | `setLateAcceptanceSize​(int lateAcceptanceSize)` |
    `void` | `stepEnded​(LocalSearchStepScope<Solution_> stepScope)` |

    - ### Methods inherited from class org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListenerAdapter

      `stepStarted`

    - ### Methods inherited from class org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter

      `solvingEnded, solvingStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.localsearch.event.LocalSearchPhaseLifecycleListener

      `stepStarted`

    - ### Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener

      `solvingEnded, solvingStarted`

- - ### Field Detail

    - #### lateAcceptanceSize

          protected int lateAcceptanceSize

    - #### hillClimbingEnabled

          protected boolean hillClimbingEnabled

    - #### previousScores

          protected Score[] previousScores

    - #### lateScoreIndex

          protected int lateScoreIndex

  - ### Constructor Detail

    - #### LateAcceptanceAcceptor

          public LateAcceptanceAcceptor()

  - ### Method Detail

    - #### setLateAcceptanceSize

          public void setLateAcceptanceSize​(int lateAcceptanceSize)

    - #### setHillClimbingEnabled

          public void setHillClimbingEnabled​(boolean hillClimbingEnabled)

    - #### phaseStarted

          public void phaseStarted​(LocalSearchPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseStarted` in interface `LocalSearchPhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseStarted` in class `LocalSearchPhaseLifecycleListenerAdapter<Solution_>`

    - #### isAccepted

          public boolean isAccepted​(LocalSearchMoveScope<Solution_> moveScope)

      Parameters:
        `moveScope` - not null
      Returns:
        true if accepted

    - #### stepEnded

          public void stepEnded​(LocalSearchStepScope<Solution_> stepScope)

      Specified by:
        `stepEnded` in interface `LocalSearchPhaseLifecycleListener<Solution_>`
      Overrides:
        `stepEnded` in class `LocalSearchPhaseLifecycleListenerAdapter<Solution_>`

    - #### phaseEnded

          public void phaseEnded​(LocalSearchPhaseScope<Solution_> phaseScope)

      Specified by:
        `phaseEnded` in interface `LocalSearchPhaseLifecycleListener<Solution_>`
      Overrides:
        `phaseEnded` in class `LocalSearchPhaseLifecycleListenerAdapter<Solution_>`